module hamming1(in,error,d,g,out);
input [3:0]in;
input [3:0]error;
output [3:1]g; //test
output [3:0]out;
wire [2:0]c; //checkbit
wire [7:1]b; //temp
output [3:0]d; //corrupted data

assign c[0]=in[0]^in[1]^in[3];
assign c[1]=in[0]^in[2]^in[3];
assign c[2]=in[1]^in[2]^in[3];

assign d[3]=in[3]^error[3];
assign d[2]=in[2]^error[2];
assign d[1]=in[1]^error[1];
assign d[0]=in[0]^error[0];

assign b[7]=d[3];
assign b[6]=d[2];
assign b[5]=d[1];
assign b[4]=c[2];
assign b[3]=d[0];
assign b[2]=c[1];
assign b[1]=c[0];

assign g[1]=b[1]^b[3]^b[5]^b[7];
assign g[2]=b[2]^b[3]^b[6]^b[7];
assign g[3]=b[4]^b[5]^b[6]^b[7];

assign out[0]=d[0]^(~g[3]&g[2]&g[1]);
assign out[1]=d[1]^(g[3]&~g[2]&g[1]);
assign out[2]=d[2]^(g[3]&g[2]&~g[1]);
assign out[3]=d[3]^(g[3]&g[2]&g[1]);

endmodule
